package com.example.hellojsf.web;

import com.example.hellojsf.dto.Person;
import com.example.hellojsf.mock.PersonStore;
import jakarta.annotation.PostConstruct;
import jakarta.enterprise.context.RequestScoped;
import jakarta.enterprise.context.SessionScoped;
import jakarta.faces.view.ViewScoped;
import jakarta.inject.Inject;
import jakarta.inject.Named;

import java.io.Serializable;
import java.util.List;

@Named
@ViewScoped
public class ListPersonsBean implements Serializable {
    @Inject
    private PersonStore personStore;

    @Inject
    private UpdatePersonBean updatePersonBean;

    @PostConstruct
    public void init() {
        persons = personStore.getAllPersons();
    }

    private List<Person> persons;
    public List<Person> getAllPersons() {
        return persons;
    }

    public void doDeletePerson(Person person) {
        personStore.removePerson(person.getId());
        init();
    }
    public void doDeActivatePerson(Person person) {
        personStore.deactivatePerson(person.getId());
        init();
    }
    public void doActivatePerson(Person person) {
        personStore.activatePerson(person.getId());
        init();
    }
    public String doUpdatePerson(Person person) {
        updatePersonBean.init(person.getId());
        return "updatePerson";
    }
}
